/* Teknisa - Tecnologia em Informtica

 Nome: 0317_CUSFUN_DATAREF_CUSTO_PRODUTO.SQL

 Descrio:
 Funo para retornar a data que o custo foi encontrado.

 Criao:
 20/10/2003 - Alexis Tolentino de Moura

@C:\WEB_411\Sql\End_Conv\Oracle\0317_CUSFUNO_DATAREF_CUSTO_PRODUTO.SQL
*/


CREATE OR REPLACE FUNCTION DATAREF_CUSTO_PRODUTO(
   P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
   P_CDPRODUTO    IN PRODUTO.CDPRODUTO%TYPE,
   P_NRTIPOCUSTO  IN NUMBER,
   P_DTREFERENCIA IN DATE,
   P_DTATUAL      IN DATE) RETURN DATE IS

   V_DTREFERENCIA DATE;
   V_DTREFECUSTO  DATE;
   V_IDUTILDTPROC VARCHAR2(1);
   V_CDFILIAL     VARCHAR2(4);
BEGIN

   IF P_NRTIPOCUSTO IN (1,2,3,4,20,21,22,23,24,25,26,27,40,41,42,43,49,50,53,54) THEN /*Custos que tem valores na tabela POSESTCONS*/

      IF (P_NRTIPOCUSTO IN (1,2,20,21,22,23,40,41,49,50,51,52)) THEN         /*Custo Mdio Atual*/
         SELECT NVL(IDUTILDTPROC, 'N')
         INTO V_IDUTILDTPROC
         FROM PARAMGERAL
         WHERE CDPARGERAL = '0001';
         IF V_IDUTILDTPROC = 'N' THEN
            V_DTREFERENCIA := P_DTATUAL;
         ELSE
            SELECT NVL(DTPROCESSA, P_DTATUAL)
            INTO V_DTREFERENCIA
            FROM PARAMFILIAL P
            WHERE CDFILIAL = P_CDFILIAL;
         END IF;
      ELSE
         V_DTREFERENCIA := P_DTREFERENCIA;                 /*Custo Mdio da poca*/
      END IF;

      BEGIN
         SELECT DTPOSESTCON
           INTO V_DTREFECUSTO
           FROM (SELECT PD.DTPOSESTCON
                   FROM POSESTCONS PD
                  WHERE CDFILIAL  = P_CDFILIAL
                    AND CDPRODUTO = P_CDPRODUTO
                    AND DTPOSESTCON <= (V_DTREFERENCIA+1)
                  ORDER BY 1 DESC)
          WHERE ROWNUM = 1;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DTREFECUSTO := NULL;
      END;

   ELSIF P_NRTIPOCUSTO IN (6,7,10,30,31,32,33,44,48,45,59,60,61,62) THEN /*Custos que tem valores na tabela CUSTOSUP*/

      IF P_NRTIPOCUSTO IN (44, 45, 48, 59, 60, 61, 62) THEN
         SELECT
            MAX(P.CDFILIOPELOG)
         INTO
            V_CDFILIAL
         FROM
            PARAMPRODSUP P
         WHERE
            P.CDFILIAL  = P_CDFILIAL AND
            P.CDPRODUTO = P_CDPRODUTO;
         IF V_CDFILIAL IS NULL THEN
            V_CDFILIAL := P_CDFILIAL;
         END IF;
      ELSE
         V_CDFILIAL := P_CDFILIAL;
      END IF;

      SELECT MAX(DTCUSTOSUP) INTO V_DTREFECUSTO
      FROM CUSTOSUP
      WHERE CDFILIAL  = V_CDFILIAL  AND
            CDPRODUTO = P_CDPRODUTO AND
            VRCUSPRLISTP IS NOT NULL AND
            DTCUSTOSUP <= P_DTREFERENCIA;

   ELSIF P_NRTIPOCUSTO IN (8,9,28,29,46,47) THEN /*Custos que tem valores na tabela POSESTDIA*/
      SELECT MAX(C.DTCUSTCMPPRO) INTO V_DTREFECUSTO
      FROM CUSTOCMPPROD C
      WHERE C.CDFILIAL       = P_CDFILIAL   AND
            C.CDPRODUTO      = P_CDPRODUTO  AND
            C.DTCUSTCMPPRO   <= P_DTREFERENCIA;

   END IF;

   RETURN(V_DTREFECUSTO);
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('DATAREF_CUSTO_PRODUTO','6.49.046'); END;
/

